//
// CPU
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "common/GMLuaModule.h"
//#include <stdio.h>
//#include <conio.h>
//#include <mmsystem.h>
#include "jb01_compress.h"
#include "jb01_decompress.h"


// This is a macro to make life easier.
// When the dll is loaded it will call the function (Init)

GMOD_MODULE(Init, Shutdown);

unsigned char data2_file2_name2[5120000];






// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - Implementations - - - - - - - - - - - - - - - - - - - - - - - - - - - -

void Error(const char * s)
{
g_Lua->LuaError(s);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

///////////////////////////////////////////////////////////////////////////////
// mainGetFileSize()
//
// Uses Win32 functions to quickly get the size of a file (rather than using
// fseek/ftell which is slow on large files
//
// Use BEFORE opening a file! :)
//
///////////////////////////////////////////////////////////////////////////////

ULONG mainGetFileSize(const char *szFile)
{
	HANDLE	hFile;
	ULONG	nSize;

	hFile = CreateFile(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL, NULL);

	if ( hFile == INVALID_HANDLE_VALUE )
		return 0;
	
	nSize = GetFileSize(hFile, NULL);

	CloseHandle(hFile);

	return nSize;

} // mainGetFileSize()


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -





void Encode_File(char * data_file_name, char * code_file_name)
{
		int					nRes;
 // How big is the source file?
		//nUncompressedSize = mainGetFileSize(argv[2]);
		//printf("Input file size      : %d\n", nUncompressedSize);
		JB01_Compress	oCompress;
		// Do the compression
		oCompress.SetDefaults();
		oCompress.SetInputType(HS_COMP_FILE);
		oCompress.SetOutputType(HS_COMP_FILE);
		oCompress.SetInputFile(data_file_name);
		oCompress.SetOutputFile(code_file_name);
//		oCompress.SetMonitorCallback(&CompressMonitorProc);
		oCompress.SetCompressionLevel(4);
		//DWORD dwTime1 = timeGetTime();
		nRes = oCompress.Compress();
		//DWORD dwTime2 = timeGetTime();

		if (nRes != JB01_E_OK)
		{
			Error("Error compressing.\n");
			return;
		}

		return;
}


void Encode_String(char * data_file_name, char * code_file_name)
{
const char * code2_file_name = code_file_name;
	const char * data3_file_name = data_file_name;
	unsigned char * data2_file_name = reinterpret_cast <unsigned char*> (data_file_name);

		int					nRes;
		unsigned long bob2 = strlen(data3_file_name) + 1;

	JB01_Compress	oCompress;
		// Do the compression
		oCompress.SetDefaults();
		oCompress.SetInputType(HS_COMP_MEM);
		oCompress.SetOutputType(HS_COMP_FILE);
		oCompress.SetInputBuffer(data2_file_name, bob2);
		oCompress.SetOutputFile(code2_file_name);
		oCompress.SetCompressionLevel(4);
		nRes = oCompress.Compress();

		if (nRes != JB01_E_OK)
		{
			Error("Error compressing.\n");
			return;
		}

		return;
}

void Decode_File(char * code_file_name,char * data_file_name)
{
  		// How big is the source file?
	//	nCompressedSize = mainGetFileSize(argv[2]);

	int					nRes;
	JB01_Decompress	oDecompress;
		// Do the uncompression
		oDecompress.SetDefaults();
		oDecompress.SetInputType(HS_COMP_FILE);
		oDecompress.SetOutputType(HS_COMP_FILE);
		oDecompress.SetInputFile(code_file_name);
		oDecompress.SetOutputFile(data_file_name);
//		oDecompress.SetMonitorCallback(&DecompressMonitorProc);
		//DWORD dwTime1 = timeGetTime();
		nRes = oDecompress.Decompress();
		//DWORD dwTime2 = timeGetTime();
		
		if (nRes != JB01_E_OK)
		{
			Error("Error uncompressing.\n");
			return;
		}
		return;
}


char* Decode_To_String( char * code_file_name)
{
 
	//unsigned char * data_file_name;
	const char * code2_file_name = code_file_name;
		int					nRes;
		//unsigned long bob2 = strlen(code2_file_name) + 1;
		//data_file_name = (unsigned char*)malloc(sizeof(UCHAR)*5120000);
//int size = strlen(code_file_name);
//int i = 0;
//for ( int i = 0; (i+size) < bob2; i++ )
//{
//		data_file_name[i] = data_file_name[i+size];
//}



		JB01_Decompress	oDecompress;
		// Do the compression
		oDecompress.SetDefaults();
		oDecompress.SetInputType(HS_COMP_FILE);
		oDecompress.SetOutputType(HS_COMP_MEM);
		oDecompress.SetInputFile(code2_file_name);
		oDecompress.SetOutputBuffer(data2_file2_name2);
		nRes = oDecompress.Decompress();


		if (nRes != JB01_E_OK)
		{
			char* err = "Error";
			Error("Error compressing.\n");
			return err;
		}
char * bob = reinterpret_cast <char*> (data2_file2_name2);
//free(data_file_name);
//delete [] data_file_name;
		return bob;	
	
}

bool unzipfile(char* infile, char* outfile){
	char path[60];
::GetCurrentDirectory(60,path);
    char path2[120] = "b";
	char path3[120] = "b";
  strcpy (path2, path);
  strcat (path2, "/garrysmod/");
  strcat (path2, infile);
    strcpy (path3, path);
  strcat (path3, "/garrysmod/Data/");
  strcat (path3, outfile);
Decode_File(path2, path3);
return true;
}

bool zipfile(char* infile, char* outfile){
		char path[60];
::GetCurrentDirectory(60,path);
    char path2[120] = "b";
	char path3[120] = "b";
  strcpy (path2, path);
  strcat (path2, "/garrysmod/");
  strcat (path2, infile);
    strcpy (path3, path);
  strcat (path3, "/garrysmod/");
  strcat (path3, outfile);
Encode_File(path2, path3);
return true;
}

LUA_FUNCTION(decompressfile)
{
int nNumParameters = g_Lua->Top();

	if (nNumParameters < 2 || nNumParameters > 2 )
	{
		g_Lua->LuaError("Insufficient parameters!");
		return 0;
	}

const char* infile2 = g_Lua->GetString(1);
const char* outfile2 = g_Lua->GetString(2);

char* infile3 = const_cast <char*> (infile2);
char* outfile3 = const_cast <char*> (outfile2);

	bool bRet = unzipfile(infile3, outfile3);
	g_Lua->Push( bRet );
	return 1;
}

LUA_FUNCTION(decompresstostring)
{
int nNumParameters = g_Lua->Top();

	if (nNumParameters < 1 || nNumParameters > 1)
	{
		g_Lua->LuaError("Insufficient parameters!");
		return 0;
	}

const char* infile2 = g_Lua->GetString(1);


char* infile3 = const_cast <char*> (infile2);

char path[60];
::GetCurrentDirectory(60,path);
    char path2[120] = "b";
  strcpy (path2, path);
  strcat (path2, "/garrysmod/");
  strcat (path2, infile3);
	char* bRet = Decode_To_String(path2);
	g_Lua->Push( bRet );
	return 1;
}

LUA_FUNCTION(compressstring)
{
int nNumParameters = g_Lua->Top();

	if (nNumParameters < 2 || nNumParameters > 2)
	{
		g_Lua->LuaError("Insufficient parameters!");
		return 0;
	}

const char* infile2 = g_Lua->GetString(1);
const char* outfile2 = g_Lua->GetString(2);
char* outfile3 = const_cast <char*> (outfile2);
char* infile3 = const_cast <char*> (infile2);

char path[60];
::GetCurrentDirectory(60,path);
	char path3[120] = "b";
    strcpy (path3, path);
  strcat (path3, "/garrysmod/");
  strcat (path3, outfile3);

	Encode_String(infile3, path3);
	return 1;
}

LUA_FUNCTION(compressfile)
{
int nNumParameters = g_Lua->Top();

	if (nNumParameters < 2 || nNumParameters > 2)
	{
		g_Lua->LuaError("Insufficient parameters!");
		return 0;


	}

const char* infile2 = g_Lua->GetString(1);
const char* outfile2 = g_Lua->GetString(2);

char* infile3 = const_cast <char*> (infile2);
char* outfile3 = const_cast <char*> (outfile2);

	bool bRet = zipfile(infile3, outfile3);
	g_Lua->Push( bRet );
	return 1;
}

LUA_FUNCTION(getcompressedsize)
{
int nNumParameters = g_Lua->Top();

	if (nNumParameters < 1 || nNumParameters > 1)
	{
		g_Lua->LuaError("Insufficient parameters!");
		return 0;
	}
	
const char* infile2 = g_Lua->GetString(1);


char* infile3 = const_cast <char*> (infile2);

char path[60];
::GetCurrentDirectory(60,path);
    char path2[120] = "b";
  strcpy (path2, path);
  strcat (path2, "/garrysmod/");
  strcat (path2, infile3);
  const char* path3 = path2;
	ULONG bRet = mainGetFileSize(path3);

	float bbret = bRet;
	g_Lua->Push( bbret );
	return 1;
}

// When the DLL is initialized it will call this function to set itself up
// It should be used to set up your library so it's all ready to go

int Init (void)
{
	// Lets make a global table filled with functions (a module)

	g_Lua->NewGlobalTable("gmodzip");

	ILuaObject* table = g_Lua->GetGlobal("gmodzip");

		table->SetMember("compressfile", compressfile);
		table->SetMember("decompressfile", decompressfile);
		table->SetMember("decompresstostring", decompresstostring);
		table->SetMember("compressstring", compressstring);
		table->SetMember("getcompressedsize", getcompressedsize);

	// We're not deleting the table here - we're deleting the reference to it
	// If you don't do this you're leaking memory

	SAFE_UNREF(table);

	return 0;
}

// When the DLL is initialized it will call this function to set itself up
// It should be used to set up your library so it's all ready to go

int Shutdown (void)
{
	return 0;
}